//
//  ViewController.swift
//  InAppProvisioningSample_Swift
//
//  Created by jefferson silva on 13/10/2021.
//

import UIKit

class ViewController: UIViewController {
    var manager:SMIAPButtonManager?
    override func viewDidLoad() {
        super.viewDidLoad()
       
        let button:PKAddPassButton = PKAddPassButton()
        button.isHidden = PKAddPassesViewController.canAddPasses() ? false : true
        button.addTarget(self, action: #selector(onAddPass), for: .touchUpInside)
        button.center = CGPoint(x: self.view.frame.size.width / 2, y: self.view.frame.size.height / 2)
        self.view.addSubview(button)
    }
    
    @objc func onAddPass(){
        manager = SMIAPButtonManager(cardHolderName: "CardHolderName",
                                     primaryAccountSuffix: "CardPrimaryAccountSuffix",
                                     primaryAccountIdentifier: nil,
                                     cardID: "CardID",
                                     delegate: self,
                                     sender: self)
        manager?.addPass()
    }
}

extension ViewController: SMIAPButtonManagerDelegate{
    func didFinishWithError(_ error: Error) {
        let myError:NSError = error as NSError
        print("myError.localizedDescription -> \(myError.localizedDescription)")
        print("myError.code -> \(myError.code)")
        
        if myError.code == 2 {
            dismiss(animated: true, completion: nil)
        }
        //Error codes
        //SMIAPAddPaymentPassErrorUnsupported             = 1;
        //SMIAPAddPaymentPassErrorUnsupported             = 1;
        //SMIAPAddPaymentPassErrorUserCancelled           = 2;
        //SMIAPAddPaymentPassErrorSystemCancelled         = 3;
        //SMIAPErrorCodeUnknwonError                      = 4;
        //SMIAPErrorCodeInvalidParameter                  = 5;
        //SMIAPErrorCodeCardNotFound                      = 6;
        //SMIAPErrorCodeCardEnrollmentDenied              = 7;
        //SMIAPErrorCodeInvalidToken                      = 8;
        //SMIAPErrorSecurityCheck                         = 9;
        //SMIAPErrorMissingResponseProperty               = 10;
    }
    
    func didFinish(withSuccess pass: PKPaymentPass) {
        print("Pass state: \(pass.activationState)")
    }
}
